"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ConsequenceType(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "sequenceOntologyTerms",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_8 import opencb as opencb_2_9_3

        return {
            "exonOverlap": opencb_2_9_3.ExonOverlap,
            "proteinVariantAnnotation": opencb_2_9_3.ProteinVariantAnnotation,
            "sequenceOntologyTerms": opencb_2_9_3.SequenceOntologyTerm,
            "spliceScores": opencb_2_9_3.SpliceScores,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_8 import opencb as opencb_2_9_3

        return {
            "org.opencb.biodata.models.variant.avro.ExonOverlap": opencb_2_9_3.ExonOverlap,
            "org.opencb.biodata.models.variant.avro.ProteinVariantAnnotation": opencb_2_9_3.ProteinVariantAnnotation,
            "org.opencb.biodata.models.variant.avro.SequenceOntologyTerm": opencb_2_9_3.SequenceOntologyTerm,
            "org.opencb.biodata.models.variant.avro.SpliceScores": opencb_2_9_3.SpliceScores,
            "org.opencb.biodata.models.variant.avro.ConsequenceType": opencb_2_9_3.ConsequenceType,
        }

    __slots__ = [
        "sequenceOntologyTerms",
        "biotype",
        "cdnaPosition",
        "cdsPosition",
        "codon",
        "ensemblGeneId",
        "ensemblTranscriptId",
        "exonOverlap",
        "geneId",
        "geneName",
        "hgvs",
        "proteinVariantAnnotation",
        "source",
        "spliceScores",
        "strand",
        "transcriptAnnotationFlags",
        "transcriptFlags",
        "transcriptId",
    ]

    def __init__(
        self,
        sequenceOntologyTerms,
        biotype=None,
        cdnaPosition=None,
        cdsPosition=None,
        codon=None,
        ensemblGeneId=None,
        ensemblTranscriptId=None,
        exonOverlap=None,
        geneId=None,
        geneName=None,
        hgvs=None,
        proteinVariantAnnotation=None,
        source=None,
        spliceScores=None,
        strand=None,
        transcriptAnnotationFlags=None,
        transcriptFlags=None,
        transcriptId=None,
        validate=None,
        **kwargs
    ):
        """Initialise the opencb_2_9_3.ConsequenceType model.

        :param sequenceOntologyTerms:
        :type sequenceOntologyTerms: list[SequenceOntologyTerm]
        :param biotype:
        :type biotype: None | str
        :param cdnaPosition:
        :type cdnaPosition: None | int
        :param cdsPosition:
        :type cdsPosition: None | int
        :param codon:
        :type codon: None | str
        :param ensemblGeneId:
        :type ensemblGeneId: None | str
        :param ensemblTranscriptId:
        :type ensemblTranscriptId: None | str
        :param exonOverlap:
        :type exonOverlap: None | list[ExonOverlap]
        :param geneId:
        :type geneId: None | str
        :param geneName:
        :type geneName: None | str
        :param hgvs:
        :type hgvs: None | list[str]
        :param proteinVariantAnnotation:
        :type proteinVariantAnnotation: None | ProteinVariantAnnotation
        :param source:
        :type source: None | str
        :param spliceScores:
        :type spliceScores: None | list[SpliceScores]
        :param strand:
        :type strand: None | str
        :param transcriptAnnotationFlags:
        :type transcriptAnnotationFlags: None | list[str]
        :param transcriptFlags:
        :type transcriptFlags: None | list[str]
        :param transcriptId:
        :type transcriptId: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "2.9.3-GEL"
